RD     ;*****  RD/ASM  -  Copyright 1985 by Jack Decker
 ;A revision of DS/CMD on Public Domain Library Disk #006
 ;for use with DOS patched to store date as DD/MM/YY.
 
 ;This program eliminates the need to type in the date
 ;manually each time you power-up your computer (assuming
 ;your DOS can be forced to bypass the "DATE" prompt when
 ;it is booted up).
 
 ;This program MUST be assembled using the filename
 ;"RD/CMD".  Normally, it is used by placing the
 ;filename as part of a DOS "AUTO" command.  You may AUTO
 ;a second program along with RD by placing filename
 ;of the second program in same AUTO command line,
 ;immediately following the RD command.  For example:
 
 ;		RD PROGRAM2
 
 ;would first execute RD, then PROGRAM2.
 
 ;If there appears to be a valid date already stored in
 ;memory (as might happen if the DOS is re-booted without
 ;first turning off the power to the system), RD will
 ;simply clear the screen and exit.  However, you can
 ;force RD to execute by placing a space and
 ;exclamation point immediately following the filename:
 
 ;		RD !
 ;	or	RD ! PROGRAM2
 
 ;When RD executes, it will display the date used the last
 ;time RD was executed.  You may advance or backspace the
 ;date using the arrow keys.  When the correct date is
 ;displayed, simply press the ENTER key, which will write
 ;the date string to the file DATE/TXT and store the date
 ;in memory and also within the RD program itself, for use
 ;the next time RD is executed.
 
 ;Questions or comments MUST be accompanied by a self-
 ;addressed stamped envelope if you live in the U.S.A. or
 ;Canada (Canadian postage is O.K.) and wish a reply.
 
 ;		Jack Decker
 ;		1804 West 18th Street   Lot # 155
 ;		Sault Ste. Marie, Michigan  49783
 
 
 	ORG	6000H		;MUST end with 00H
 
 ;String and date storage area used by program
 
 TABLE	DEFW	SUN		;Table of string pointers
 	DEFW	MON		;  point to strings
 	DEFW	TUE		;  containing days of
 	DEFW	WED		;  the week
 	DEFW	THU
 	DEFW	FRI
 	DEFW	SAT
 	DEFW	JAN		;Table of string pointers
 	DEFW	FEB		;  point to strings
 	DEFW	MAR		;  containing months of
 	DEFW	APR		;  the year
 	DEFW	MAY
 	DEFW	JUN
 	DEFW	JUL
 	DEFW	AUG
 	DEFW	SEP
 	DEFW	OCT
 	DEFW	NOV
 	DEFW	DEC
 MARKER	DEFB	0FEH		;Start date storage area
 DATSTR	DEFB	83D		;Year storage
 	DEFB	11D		;Month storage
 	DEFB	1D		;Day storage
 	DEFB	2D		;Day of week storage
 CNTURY	DEFW	1900D		;Century storage
 SUN	DEFM	'Sunda'		;Strings containing days
 	DEFB	'y'+80H		;  of week
 MON	DEFM	'Monda'
 	DEFB	'y'+80H
 TUE	DEFM	'Tuesda'
 	DEFB	'y'+80H
 WED	DEFM	'Wednesda'
 	DEFB	'y'+80H
 THU	DEFM	'Thursda'
 	DEFB	'y'+80H
 FRI	DEFM	'Frida'
 	DEFB	'y'+80H
 SAT	DEFM	'Saturda'
 	DEFB	'y'+80H
 JAN	DEFM	'Januar'	;Strings containing
 	DEFB	'y'+80H		;  months of year
 FEB	DEFM	'Februar'
 	DEFB	'y'+80H
 MAR	DEFM	'Marc'
 	DEFB	'h'+80H
 APR	DEFM	'Apri'
 	DEFB	'l'+80H
 MAY	DEFM	'Ma'
 	DEFB	'y'+80H
 JUN	DEFM	'Jun'
 	DEFB	'e'+80H
 JUL	DEFM	'Jul'
 	DEFB	'y'+80H
 AUG	DEFM	'Augus'
 	DEFB	't'+80H
 SEP	DEFM	'Septembe'
 	DEFB	'r'+80H
 OCT	DEFM	'Octobe'
 	DEFB	'r'+80H
 NOV	DEFM	'Novembe'
 	DEFB	'r'+80H
 DEC	DEFM	'Decembe'
 	DEFB	'r'+80H
 MSG	DEFB	1CH		;1CH will home cursor
 	DEFB	1FH		;1FH will clear screen
 	DEFB	1AH		;1AH moves down one line
 	DEFB	1AH
 	DEFM	'Please set correct date:'
 	DEFB	0DH
 	DEFB	1AH
 	DEFB	1AH
 	DEFB	1AH
 	DEFM	'Please press one of the following keys:'
 	DEFB	0DH
 	DEFM	'<ENTER> if date is correct'
 	DEFB	0DH
 	DEFM	'<BREAK> or <CLEAR> to exit without setting date'
 	DEFB	0DH
 	DEFM	'<up-arrow> or <right-arrow> to advance date'
 	DEFB	0DH
 	DEFM	'<down-arrow> or <left-arrow> to backup date'
 	DEFB	0DH
 	DEFM	'<SHIFT> plus arrow key to change date at high speed'
 	DEFB	1CH		;1CH will home cursor
 	DEFB	1AH		;1AH moves down one line
 	DEFB	1AH
 	DEFB	1AH
 	DEFB	1AH+80H
 ENDYR	DEFB	1EH		;1EH clears to line end
 	DEFB	1DH+80H		;1DH moves to line start
 
 ;Start of actual machine-language program
 
 START	LD	A,(HL)		;Get argument (!) if any
 	CP	'!'		;Is it exclamation point
 	PUSH	AF		;Save result (Z flag)
 	CALL	Z,1D78H		;Bump HL past excl. point
 	POP	AF		;Restore Z flag
 	PUSH	HL		;Save input buffer pointr
 	JR	Z,USEPGM	;Skip date test if ! used
 	CALL	GETBFR		;Get loc memory date stor
 	LD	A,(DE)		;Get year from memory
 	CP	100D		;Is it in range 00 - 99?
 	JR	NC,USEPGM	;Go if invalid year
 	INC	DE		;Point to month in memory
 	LD	A,(DE)		;Get month from memory
 	DEC	A		;Adjust valid to 0 - 11
 	CP	12D		;Is month 1 - 12 in mem?
 	JR	NC,USEPGM	;Go if invalid month
 	INC	DE		;Point to day in memory
 	LD	A,(DE)		;Get day from memory
 	DEC	A		;Adjust valid to 0 - 30
 	CP	31D		;Is day 1 - 31 in memory?
 	JP	C,EXIT2		;Go if memory date valid
 USEPGM	LD	HL,MSG		;Point to message
 	CALL	DSPMSG		;Display message
 RESTRT	LD	BC,DATSTR+3	;Point to day of wk byte
 	LD	A,(BC)		;Get day of week (0 - 6)
 	CALL	PRTSTR		;Print day of week string
 	CALL	PRTCOM		;Print comma and space
 	DEC	BC		;Point to day byte
 	CALL	PRTDAT		;Print day, month & year
 	LD	HL,ENDYR	;Point to ctrl chr string
 	CALL	DSPMSG		;Output it to video
 GETKEY	LD	A,(3840H)	;Get BREAK/CLEAR row
 	AND	6		;Mask out other keys
 	JR	NZ,EXIT		;Exit if BREAK/CLEAR
 	CALL	2BH		;Get keystroke if any
 	OR	A		;Z flag set if no key
 	JR	Z,GETKEY	;If no key was pressed
 	CP	0DH		;Was it the ENTER key?
 	JR	NZ,NOTCR	;Go if not ENTER
 	LD	HL,DATSTR	;Point to program date
 	PUSH	HL		;Save program date pntr
 	CALL	GETBFR		;Find memory date storage
 	LD	BC,3		;Number of bytes to move
 	LDIR			;Move from program to mem
 	LD	B,0		;Logical Record Lngth=256
 	LD	DE,FCB		;File Control Block pntr
 	LD	HL,FILBUF	;File I/O Buffer pntr
 	CALL	4424H		;DOS OPEN routine
 ERREXT	JP	NZ,4409H	;If error use ERROR rtne
 	CALL	4436H		;READ sector 0 to buffer
 	JR	NZ,ERREXT	;Go if error
 	POP	HL		;Get program date pointer
 	PUSH	DE		;Save FCB pointer
 	LD	DE,MARKER-TABLE+4+FILBUF
 ;Above instruction points DE to first location in sector
 ;zero of disk file that can possibly contain MARKER byte
 FNDDAT	LD	A,(DE)		;Get byte frm disk sector
 	INC	DE		;Bump pointer to next loc
 	CP	0FEH		;MARKER byte found?
 	JR	NZ,FNDDAT	;Try again if not
 	LD	BC,4		;Move 4 bytes frm program
 	LDIR			;  storage to disk sector
 	POP	DE		;Restore FCB pointer
 	CALL	443FH		;Reset to sector zero
 	JR	NZ,ERREXT	;Go if error
 	CALL	4439H		;Write sector back to dsk
 	JR	NZ,ERREXT	;Go if error
 ;Do NOT attempt to CLOSE file after above procedure!!
 ;It is not necessary, and will truncate file if you do!
 EXIT	CALL	1C9H		;Clear screen
 EXIT2	CALL	GETBFR		;Get loc memory date stor
 	PUSH	DE		;Save memory date storage
 	LD	B,0		;Logical Record Lngth=256
 	LD	DE,FCB2		;File Control Block pntr
 	LD	HL,FILBUF	;File I/O Buffer pntr
 	CALL	4420H		;DOS INIT routine
 	JR	NZ,ERREXT	;Go if error
 	POP	BC		;Get memory date storage
 	INC	BC		;Point to month byte
 	INC	BC		;Point to day byte
 	LD	A,1BH		;ROM "byte output" addr
 	LD	(OUTCHR+1),A	;Change program vector
 	CALL	PRTDAT		;Output date to file
 	LD	A,0DH		;Carriage return in A
 	CALL	OUTCHR		;Output it to file
 	CALL	4428H		;CLOSE file
 	POP	HL		;Restore input buffer ptr
 	LD	A,0DH		;Check for <CR> character
 	CP	(HL)		;  (end of command strng)
 	JP	Z,402DH		;DOS READY if no more cmd
 	JP	4405H		;Execute next DOS command
 NOTCR	CP	5BH		;Was keystroke up-arrow?
 	JR	Z,ARROW		;Go if up-arrow
 	LD	B,A		;Save keystroke in B
 	OR	10H		;Make shifted=unshifted
 	CP	18H		;Invalid keystroke if
 	JP	C,GETKEY	;  less than ASCII 18H
 	CP	1CH		;Keystroke valid if less
 	JP	NC,GETKEY	;  than ASCII 1CH
 	XOR	B		;Check for shifted char
 	JR	NZ,UNSHFT	;If not shifted char
 	LD	(403CH),A	;Zero arrow row storage
 UNSHFT	LD	A,B		;Restore original char
 ARROW	LD	HL,RESTRT	;RET addr for following
 	PUSH	HL		;Save it on stack
 	LD	HL,DATSTR+3	;Point to day-of-week
 	RRCA			;Shift bit 0 into carry
 	JR	NC,BACK		;If key was back/down arr
 ADV	INC	(HL)		;Increment day of week
 	LD	A,(HL)		;Get day of week
 	CP	7		;Is it greater than 6?
 	JR	C,SETDAY	;Go if valid day
 	LD	(HL),0		;Else reset to Sunday
 SETDAY	DEC	HL		;Bump pointer down to
 	DEC	HL		;  month storage
 	LD	A,(HL)		;Get month
 	CALL	MAXDAY		;Get number days in month
 	INC	HL		;Point to day storage
 	LD	A,(HL)		;Get current day
 	CP	C		;Compare with maximum
 	INC	(HL)		;Advance day of month
 	RET	C		;Finished if valid day
 	LD	(HL),1		;Else first of new month
 	DEC	HL		;Point to month storage
 	LD	A,(HL)		;Get current month
 	CP	12D		;See if it's December
 	INC	(HL)		;Advance month count
 	RET	C		;Finished if valid month
 	LD	(HL),1		;Else January of new year
 	DEC	HL		;Point to year storage
 	LD	A,(HL)		;Get current year
 	CP	99D		;See if last of century
 	INC	(HL)		;Advance year count
 	RET	C		;Finished if valid year
 	LD	(HL),0		;Else reset year count
 	LD	DE,100D		;Add 100 years to century
 CHGCEN	LD	HL,(CNTURY)	;Get current century
 	ADD	HL,DE		;Adjust century offset
 	LD	(CNTURY),HL	;  and re-save it
 	RET			;Finished for sure
 BACK	DEC	(HL)		;Decrement day of week
 	JP	P,SETDA2	;Go if valid day
 	LD	(HL),6		;Else reset to Saturday
 SETDA2	DEC	HL		;Bump pointer down to
 	DEC	HL		;  month storage
 	LD	A,(HL)		;Get month
 	INC	HL		;Point to day storage
 	DEC	(HL)		;Decrement day of month
 	RET	NZ		;Finished if valid day
 	DEC	A		;Else A=# of previous mth
 	CALL	MAXDAY		;Get # days previous mnth
 	LD	(HL),C		;Day=last day prev. month
 	DEC	HL		;Point to month storage
 	DEC	(HL)		;Decrement month count
 	RET	NZ		;Finished if valid month
 	LD	(HL),12D	;Else December prev. year
 	DEC	HL		;Point to year storage
 	DEC	(HL)		;Decrement year count
 	RET	P		;Finished if valid year
 	LD	(HL),99D	;Else last yr prev cntury
 	LD	DE,-100D	;Subtract 100 frm century
 	JR	CHGCEN		;Adjust century & finish
 PRTSTR	RLCA			;A=A*2 (2 byte pointers)
 	LD	L,A		;L=LSB string table addr
 	LD	H,TABLE<-8	;H=MSB string table addr
 	LD	A,(HL)		;A=LSB actual string addr
 	INC	HL		;Point to MSB string addr
 	LD	H,(HL)		;H=MSB actual string addr
 	LD	L,A		;HL=string location addr
 DSPMSG	LD	A,(HL)		;Get byte to display
 	OR	A		;See if zero terminator
 	RET	Z		;Finished if zero byte
 	PUSH	AF		;Save sign flag status
 	AND	7FH		;Mask off bit 7
 	CALL	OUTCHR		;Display it on video
 	POP	AF		;Restore sign flag
 	RET	M		;Finished if bit 7 set
 	INC	HL		;Advance string pointer
 	JR	DSPMSG		;Go print next byte
 PRTDAT	LD	A,(BC)		;Get day (1 - 31)
 	LD	L,A		;Put day in L
 	LD	H,0		;HL = day
 	PUSH	BC		;Save date storage pntr
 	CALL	PRTNUM		;Print day
 	POP	BC		;Restore date storage ptr
 	CALL	PRTSPC		;Print space character
 	DEC	BC		;Point to month byte
 	LD	A,(BC)		;Get month (1 - 12)
 	ADD	A,6		;Offset for string table
 	CALL	PRTSTR		;Print month string
 	CALL	PRTSPC		;Print space character
 	DEC	BC		;Point to year byte
 	LD	A,(BC)		;Get year (0 - 99)
 	LD	C,A		;Put year in C
 	LD	B,0		;BC = last 2 digits year
 	LD	HL,(CNTURY)	;Get century offset
 	ADD	HL,BC		;HL = Year (all 4 digits)
 PRTNUM	PUSH	DE		;Save DE
 	CALL	0A9AH		;Number in HL to ACCUM
 	CALL	0FBDH		;Convert # to string
 	INC	HL		;Skip leading space char
 	POP	DE		;Restore DE
 	JR	DSPMSG		;Display converted number
 PRTCOM	LD	A,','		;Comma character in A
 	CALL	OUTCHR		;Display it on video
 PRTSPC	LD	A,' '		;Space character in A
 	JR	OUTCHR		;Display on video & RET
 GETBFR	LD	DE,4044H	;DE=Mod I date storage
 	LD	A,(54H)		;Check which model TRS-80
 	DEC	A		;A will be 0 on Model I
 	RET	Z		;Return if Model I
 	LD	DE,421AH	;DE=Mod III date storage
 	RET			;Pointing to Mod III date
 MAXDAY	LD	C,30D		;C=# days in some months
 	CP	4		;Is month April?
 	RET	Z		;Return if April
 	CP	6		;Is month June?
 	RET	Z		;Return if June
 	CP	9		;Is month September?
 	RET	Z		;Return if September
 	CP	11D		;Is month November?
 	RET	Z		;Return if November
 	INC	C		;C=31 (# days most mnths)
 	CP	2 		;Is month February?
 	RET	NZ		;Return if 31 day month
 	LD	C,28D		;C=# days in February
 	LD	A,(DATSTR)	;Get current year
 	AND	3		;Year divisible by 4?
 	RET	NZ		;If not leap year
 	INC	C		;C=29 (# days leap Feb.)
 	RET			;Finished
 OUTCHR	JP	33H		;Adr modified for dsk I/O
 FCB2	DEFM	'DATE/TXT'	;Second FCB area (uses
 	DEFB	3		;  part of original FCB)
 FCB	DEFM	'RD/CMD'	;File Control Block area
 	DEFB	3		;  with program filename
 	DEFS	25D		;  (total 32 bytes)
 FILBUF	DEFS	100H		;File I/O buffer area
 	END	START
